summaryrefslogtreecommitdiff
path: root/t/built-sources.sh
diff options
context:
space:
mode:
authorStefano Lattarini <stefano.lattarini@gmail.com>2012-10-27 15:38:46 +0200
committerStefano Lattarini <stefano.lattarini@gmail.com>2012-10-27 16:01:19 +0200
commit44d202536a5fd0ac670eef7f43326093c8c9bc5b (patch)
tree0cea30165b6523517456fc2b8861a29ee44cdc0e /t/built-sources.sh
parent7a3e5c7c58d5f3dab27776b5b07e3d4e1b2e5fdd (diff)
downloadautomake-44d202536a5fd0ac670eef7f43326093c8c9bc5b.tar.gz
tests: move coverage about BUILT_SOURCES
Basically a backport of some tests from Automake-NG. * t/built-sources-check.sh: Sync it with the version in the ng/master branch. Accordingly, move part of the checks out ... * t/built-sources-install.sh: ... into this new test, synced from ng/master as well. * t/built-sources-subdir.sh: Minor tweaks and enhancements to sync it with the version in ng/master. * t/built-sources-cond.sh: New test, synced from ng/master. * t/built-sources.sh: Likewise, with minor edits to avoid a spurious failure. * t/built-sources-fork-bomb.sh: Likewise. * t/list-of-tests.mk: Update. Signed-off-by: Stefano Lattarini <stefano.lattarini@gmail.com>
Diffstat (limited to 't/built-sources.sh')
-rwxr-xr-xt/built-sources.sh68
1 files changed, 68 insertions, 0 deletions
diff --git a/t/built-sources.sh b/t/built-sources.sh
new file mode 100755
index 000000000..517313660
--- /dev/null
+++ b/t/built-sources.sh
@@ -0,0 +1,68 @@
+#! /bin/sh
+# Copyright (C) 2003-2012 Free Software Foundation, Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+# Basic test on BUILT_SOURCES.
+
+required=cc
+. ./defs || exit 1
+
+cat >> configure.ac <<'END'
+AC_PROG_CC
+AC_OUTPUT
+END
+
+cat > Makefile.am << 'END'
+BUILT_SOURCES = foo.c
+noinst_PROGRAMS = bar baz
+foo.c:
+ rm -f $@ $@-t
+## Use printf, not echo, to avoid spurious interpretation of
+## the "\n" as a newline (seen on NetBSD 5.1).
+ printf '%s\n' '#include <stdio.h>' > $@-t
+ printf '%s\n' 'int main (void)' >> $@-t
+ printf '%s\n' '{ ' >> $@-t
+ printf '%s\n' ' printf ("%s\n", FOOMSG);' >> $@-t
+ printf '%s\n' ' return 0;' >> $@-t
+ printf '%s\n' '}' >> $@-t
+ mv -f $@-t $@
+CLEANFILES = foo.c
+END
+
+cat > bar.c <<'END'
+#define FOOMSG "Howdy, World"
+#include "foo.c"
+END
+
+cat > baz.c <<'END'
+#define FOOMSG "Hello, Earth"
+#include "foo.c"
+END
+
+$ACLOCAL
+$AUTOMAKE
+$AUTOCONF
+
+./configure
+$MAKE
+if cross_compiling; then :; else
+ ./bar
+ ./bar | grep 'Howdy, World'
+ ./baz
+ ./baz | grep 'Hello, Earth'
+fi
+$MAKE distcheck
+
+: